=== debian/changelog ===
cmake (3.16.3-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Feb 2020 17:49:40 -0800

cmake (3.16.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #949964)

 -- Felix Geyer <fgeyer@debian.org>  Sun, 02 Feb 2020 14:59:35 +0100

cmake (3.15.4-1) unstable; urgency=medium

  * New upstream release. (Closes: #944090)
  * Disable FIleAPI json-extra test for now as it doesn't seem critical and
    fails with libjsoncpp 1.7.4.
  * Switch to debhelper compat level 12.
  * Pass --fail-missing to dh_missing.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 12 Nov 2019 20:11:25 +0100
